﻿using System;
using System.Drawing;
using System.Reflection;
using System.Runtime.InteropServices;

namespace LoadIconSample {

    internal static class IconExtractor {

        public static Bitmap GetAppIcon() {
            System.IntPtr hLibrary = NativeMethods.LoadLibrary(Assembly.GetEntryAssembly().Location);
            if (!hLibrary.Equals(System.IntPtr.Zero)) {
                System.IntPtr hIcon = NativeMethods.LoadIcon(hLibrary, "#32512");
                if (!hIcon.Equals(System.IntPtr.Zero)) {
                    Bitmap bitmap = System.Drawing.Icon.FromHandle(hIcon).ToBitmap();
                    if (bitmap != null) { return bitmap; }
                }
            }
            return null;
        }


        private static class NativeMethods {

            [DllImport("user32.dll", CharSet = CharSet.Unicode)]
            static extern internal IntPtr LoadIcon(IntPtr hInstance, string lpIconName);

            [DllImport("kernel32.dll", CharSet = CharSet.Unicode)]
            static extern internal IntPtr LoadLibrary(string lpFileName);

        }

    }
}
